
        ----------------- MDS.e ------------------

--Convert files containing expressions under Euphoria v2.5 that use
--  the dollar sign for sequence indexing to files compatible with
--  Euphoria v2.4 .

--Copyright 2004 by Al Getz


include file.e
include wildcard.e

constant MAXLINELENGTH=80

integer Converted
Converted=0


function RemoveFalseDollars(sequence s)
  --find all $ inside quotes or after rem and change to #FF

  integer q,InsideQuotes,RemFound,chr,qchr

  InsideQuotes=0
  RemFound=0

  qchr=0
  for k=1 to length(s) do
    chr=s[k]
    q=0
    if qchr=0 then
      if chr=34 or chr=39 then
        qchr=chr
      end if
    end if
    if chr=qchr then
      q=1
      if k-1>0 then
        if s[k-1]='\\' then
          q=0
          if k-2>0 then
            if s[k-2]='\\' then
              q=1
            end if
          end if
        end if
      end if
    end if
  
    if q=1 then
      --TrueQuotes=append(TrueQuotes,k)
      if InsideQuotes=1 then
        InsideQuotes=0
        qchr=0
      else
        InsideQuotes=1
      end if
    end if
  
    if not(InsideQuotes) then
      if chr='-' then
        if k+1<=length(s) then
          if s[k+1]='-' then
            RemFound=1
          end if
        end if
      end if
    else
      if chr='$' then
        s[k]=#FF
      end if
    end if
  
    if RemFound then
      for i=k+2 to length(s) do
        if s[i]='$' then
          s[i]=#FF
        end if
      end for
      exit
    end if
  
  end for

  return s

end function


function ValidVarChar(integer c)
  if ('a'<=c and c<='z') or
     ('A'<=c and c<='Z') or
     '_'=c or
     ':'=c then
    return 1
  else
    return 0
  end if

end function



function MutateDollars(sequence s)
  integer pos1,pos2,posD,chr,x
  sequence name,string

  while 1 do
    pos1=find('$',s)
    pos2=0
    if pos1 then
      posD=pos1
      x=1
      for k=posD to 1 by -1 do
        chr=s[k]
        if chr=']' then
          x=x+1
        elsif chr='[' then
          x=x-1
        end if
        if x=0 and chr='[' and pos2=0 then
            pos2=k-1
        end if

        if chr!=' ' then
          if x=0 and chr!='[' then
            if ValidVarChar(chr) then
              --end of var name found
              pos1=1
              for i=k to 1 by -1 do
                if not(ValidVarChar(s[i])) then
                  pos1=i+1
                  exit
                end if
              end for
              name=s[pos1..pos2]
              string="length("&name&")"
              s=s[1..posD-1]&string&s[posD+1..length(s)]
              Converted=1
              exit
            end if
          end if
        end if
      end for
    else
      exit
    end if
  end while

  return s
end function


function ReplaceDollars(sequence s)
  integer pos

  while 1 do
    pos=find(#FF,s)
    if pos then
      s[pos]='$'
    else
      exit
    end if
  end while
  return s
end function



global function ConvertLine(sequence line)
  if length(line)<4 then
    return line
  end if

  line=RemoveFalseDollars(line)
  line=MutateDollars(line)
  line=ReplaceDollars(line)

  return line
end function


global procedure ConvertFile(sequence pathin, sequence pathout)
  atom fni, fno
  sequence origline
  object line
  integer NotFound,chr

  fni=open(pathin,"r")
  fno=open(pathout,"w")

  while 1 do
    line=gets(fni)
    if atom(line) then
      exit
    end if

    origline=line
    Converted=0
    if find('$',line) then
      line=ConvertLine(line)
    end if
    if Converted then
      puts(fno,"--"&origline)
      NotFound=1
      while length(line)>MAXLINELENGTH do
        for k=MAXLINELENGTH to 1 by -1 do
          chr=line[k]
          if chr=']' or chr=')' or chr='}' or chr=',' or chr='=' then
            NotFound=0
            puts(fno,line[1..k]&"\n")
            line=line[k+1..length(line)]
            exit
          end if
        end for
        if NotFound=1 then
          exit
        end if
      end while
    end if
    puts(fno,line)

  end while

  close(fni)
  close(fno)

end procedure

function GetExt(sequence filename)
  sequence Ext

  Ext=""
  for k=length(filename) to 1 by -1 do
    if filename[k]='.' then
      Ext=filename[k+1..length(filename)]
      exit
    end if
  end for
  return Ext
end function

global procedure ConvertDirectory(sequence dirpath, sequence ExtList)
  sequence DirListA, DirListB, Ext, name, dirpath2

  puts(1, "Starting...\n\n")

  ExtList=upper(ExtList)

  if dirpath[length(dirpath)]='\\' then
    dirpath=dirpath[1..length(dirpath)-1]
  end if
  dirpath2=dirpath&"-$"

  --make a new directory for the new files?:
  if atom(dir(dirpath2)) then
    system("md "&dirpath2,0)
  end if

  dirpath=dirpath&"\\"
  dirpath2=dirpath2&"\\"

  DirListA={}
  DirListB=dir(dirpath)
  for k=1 to length(DirListB) do
    name=DirListB[k][1]
    Ext=GetExt(name)
    if find(upper(Ext),ExtList) then
      DirListA=append(DirListA,name)
    end if
  end for

  for k=1 to length(DirListA) do
    name=DirListA[k]
    puts(1, name&"\n")
    ConvertFile(dirpath&name,dirpath2&name)
  end for

  puts(1, "\n...Done\n")

end procedure


